﻿Imports System.Collections.Generic
Imports System.IO
Imports System.Net

Module Module1
    Dim calculateDistanceUrl As String = "http://trackservice.trackroad.com/rest/distance"
    Dim trackServiceKey As String = "your_trackservice_key"

    Dim addressRequest As String = "{""StartLocation"":{""MatchCode"":0,""Name"":""Stop A"",""Delivery"":null,""Vehicle"":null,""Description"":null,""Phone"":null,""LatLong"":null,""Address"":{""Street"":""6718 Whittier Avenue"",""City"":""McLean"",""State"":""VA"",""PostalCode"":""22101"",""Country"":null},""Priority"":0,""Wait"":0,""Volume"":0,""Weight"":0,""Skids"":0,""TimeConstraintArrival"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture"":""0001-01-01T00:00:00Z"",""TimeConstraintArrival2"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture2"":""0001-01-01T00:00:00Z"",""LocationType"":0,""CanArriveEarly"":true,""Distance"":0,""Time"":0},""FinishLocation"":{""MatchCode"":0,""Name"":""Stop B"",""Delivery"":null,""Vehicle"":null,""Description"":null,""Phone"":null,""LatLong"":null,""Address"":{""Street"":""1450 Old Chaing Bridge Road"",""City"":null,""State"":null,""PostalCode"":null,""Country"":null},""Priority"":0,""Wait"":0,""Volume"":0,""Weight"":0,""Skids"":0,""TimeConstraintArrival"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture"":""0001-01-01T00:00:00Z"",""TimeConstraintArrival2"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture2"":""0001-01-01T00:00:00Z"",""LocationType"":0,""CanArriveEarly"":true,""Distance"":0,""Time"":0},""DistanceUnit"":0}"
    Dim latLonRequest As String = "{""StartLocation"":{""MatchCode"":0,""Name"":""Stop B"",""Delivery"":null,""Vehicle"":null,""Description"":null,""Phone"":null,""LatLong"":{""Latitude"":-23.554533,""Longitude"":-46.6922909},""Address"":null,""Priority"":0,""Wait"":0,""Volume"":0,""Weight"":0,""Skids"":0,""TimeConstraintArrival"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture"":""0001-01-01T00:00:00Z"",""TimeConstraintArrival2"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture2"":""0001-01-01T00:00:00Z"",""LocationType"":0,""CanArriveEarly"":true,""Distance"":0,""Time"":0},""FinishLocation"":{""MatchCode"":0,""Name"":null,""Delivery"":null,""Vehicle"":null,""Description"":null,""Phone"":null,""LatLong"":{""Latitude"":-23.654533,""Longitude"":-46.49229},""Address"":null,""Priority"":0,""Wait"":0,""Volume"":0,""Weight"":0,""Skids"":0,""TimeConstraintArrival"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture"":""0001-01-01T00:00:00Z"",""TimeConstraintArrival2"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture2"":""0001-01-01T00:00:00Z"",""LocationType"":0,""CanArriveEarly"":true,""Distance"":0,""Time"":0},""DistanceUnit"":0}"

    Sub Main()
        'Calculate distance by addresses.
        CalculateDistance(trackServiceKey, addressRequest)

        'CalculateDistace by Latitude and Longitude.
        CalculateDistance(trackServiceKey, latLonRequest)
    End Sub

    Sub CalculateDistance(key As String, postData As String)
        'A data to send.
        Dim response As String = Nothing

        Try
            'Make a request.
            response = CallService(Convert.ToString(calculateDistanceUrl & Convert.ToString("/")) & key, postData)
        Catch ex As Exception
            'Show exception.
            Console.WriteLine(ex.ToString())
            Return
        End Try
        Console.WriteLine("CalculateDistance:")
        Console.WriteLine(response)
        Console.WriteLine("Press any key to continue...")
        Console.ReadKey()
    End Sub

    ''' <summary>
    ''' Sends data to specified URL as POST request and returns response.
    ''' </summary>
    ''' <param name="url">Request Url</param>
    ''' <param name="postData">A data to send.</param>
    ''' <returns>Returns a response as a System.String.</returns>
    Function CallService(url As String, postData As String) As String
        Dim httpWReq As HttpWebRequest = DirectCast(WebRequest.Create(url), HttpWebRequest)

        Dim data As Byte() = System.Text.Encoding.UTF8.GetBytes(postData)

        httpWReq.Method = "POST"
        httpWReq.ContentType = "text/json; charset=utf-8"
        httpWReq.ContentLength = data.Length

        Using stream As Stream = httpWReq.GetRequestStream()
            stream.Write(data, 0, data.Length)
        End Using

        Dim response As HttpWebResponse = DirectCast(httpWReq.GetResponse(), HttpWebResponse)

        Dim responseString As String = New StreamReader(response.GetResponseStream()).ReadToEnd()

        Return responseString
    End Function
End Module
