﻿Imports System.Collections.Generic
Imports System.IO
Imports System.Net

Module Module1

    Dim creditUrl As String = "http://trackservice.trackroad.com/rest/credit"
    Dim trackServiceKey As String = "your_trackservice_key"

    Sub Main()
        'Make a request.
        Credit(trackServiceKey)
    End Sub


    Sub Credit(key As String)
        'A data to send.
        Dim postData As String = ""

        Dim response As String = Nothing

        Try
            'Make a request.
            response = CallService(Convert.ToString(creditUrl & Convert.ToString("/")) & key, postData)
        Catch ex As Exception
            'Show exception.
            Console.WriteLine(ex.ToString())
            Return
        End Try
        Console.WriteLine("Credit:")
        Console.WriteLine(response)
        Console.WriteLine("Press any key to continue...")
        Console.ReadKey()
    End Sub

    ''' <summary>
    ''' Sends data to specified URL as POST request and returns response.
    ''' </summary>
    ''' <param name="url">Request Url</param>
    ''' <param name="postData">A data to send.</param>
    ''' <returns>Returns a response as a System.String.</returns>
    Function CallService(url As String, postData As String) As String
        Dim httpWReq As HttpWebRequest = DirectCast(WebRequest.Create(url), HttpWebRequest)

        Dim data As Byte() = System.Text.Encoding.UTF8.GetBytes(postData)

        httpWReq.Method = "POST"
        httpWReq.ContentType = "text/json; charset=utf-8"
        httpWReq.ContentLength = data.Length

        Using stream As Stream = httpWReq.GetRequestStream()
            stream.Write(data, 0, data.Length)
        End Using

        Dim response As HttpWebResponse = DirectCast(httpWReq.GetResponse(), HttpWebResponse)

        Dim responseString As String = New StreamReader(response.GetResponseStream()).ReadToEnd()

        Return responseString
    End Function

End Module